using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

namespace SimpleDataSet
{
	public class DataSetSample : System.Web.Services.WebService
	{
		protected override void Dispose( bool disposing )
		{
		}

		[WebMethod()]
		public DataSet Simple()
		{
			System.Data.DataSet dsOrders = new System.Data.DataSet();
			DataTable dt;

			// Build a dataset with four columns
			dt = new DataTable("Orders");
			DataColumn dc = new DataColumn("OrderID", typeof(string));
			dt.Columns.Add(dc);
			dc = new DataColumn("Date", typeof(string));
			dt.Columns.Add(dc);
			dc = new DataColumn("Name", typeof(string));
			dt.Columns.Add(dc);
			dc = new DataColumn("Amount", typeof(decimal));
			dt.Columns.Add(dc);

			// Populate the dataset
			DataRow dr;
			dr = dt.NewRow();

			dr["OrderID"] = System.Guid.NewGuid();
			dr["Date"] = DateTime.Now;
			dr["Name"] = "Chris Kinsman";
			dr["Amount"] = 123.45;
			dt.Rows.Add(dr);

			dr = dt.NewRow();
			dr["OrderID"] = System.Guid.NewGuid();
			dr["Date"] = DateTime.Now.AddDays(1);
			dr["Name"] = "Jeffrey McManus";
			dr["Amount"] = "234.45";
			dt.Rows.Add(dr);

			// Add the datatable to the dataset
			dsOrders.Tables.Add(dt);

			return dsOrders;
		}
	}
}
