using System;

namespace SimpleModule
{
	/// <summary>
	/// Summary description for AdInserter.
	/// </summary>
	public class AdInserter : System.Web.IHttpModule
	{
		private System.Web.HttpApplication mApplication;

		public AdInserter()
		{
		}

		public void Init(System.Web.HttpApplication application)
		{
			// Wire up beginrequest
			application.BeginRequest += new System.EventHandler(BeginRequest);
			// Save the application
			mApplication = application;
		}

		public void BeginRequest(Object sender, EventArgs e)
		{
			// Create a new filter
			AdStream mStreamFilter = new AdStream(mApplication.Response.Filter);
			// Insert it onto the page
			mApplication.Response.Filter = mStreamFilter;
		}

		// AdStream filter
		public class AdStream : System.IO.Stream
		{
			// The ads to insert
			string[] astrAds = new string[] {"<adinsert><img src=\"deep_468x60a.gif\"></adinsert>", "<adinsert><img src=\"deepASPNET_color.gif\"></adinsert>"};
		
			//	The stream to the client
			private System.IO.Stream moStream;
			// Used to track properties not supported by the client stream
			private long mlLength;
			private long mlPosition;
			// An easy way to write a stream to the client
			private System.IO.StreamWriter mSR;

			public AdStream(System.IO.Stream stream)
			{
				// Save of the stream back to the client
				moStream = stream;
				// Create a streamwriter for later use
				mSR = new System.IO.StreamWriter(moStream);
			}
				
			public override bool CanRead
			{
				get
				{
					return false;
				}
			}

			public override bool CanSeek
			{
				get
				{
					return true;
				}
			}

			public override bool CanWrite
			{
				get
				{
					return true;
				}
			}

			public override long Length
			{
				get
				{
					return mlLength;
				}
			}

			public override long Position
			{
				get
				{
					return mlPosition;
				}
				set
				{
					mlPosition = value;
				}
			}

			public override int Read(Byte[] buffer, int offset, int count)
			{
				throw new NotSupportedException();
			}

			public override long Seek(long offset, System.IO.SeekOrigin direction)
			{
				return moStream.Seek(offset, direction);
			}

			public override void SetLength(long length)
			{
				mlLength = length;
			}

			public override void Close()
			{
				moStream.Close();
			}

			public override void Flush()
			{
				moStream.Flush();
			}

			public override void Write(byte[] buffer, int offset, int count)
			{
				System.Text.UTF8Encoding utf8 = new System.Text.UTF8Encoding();
				// Get the string into a stringbuilder
				System.Text.StringBuilder strBuff = new System.Text.StringBuilder(utf8.GetString(buffer));
				// Random number used to grab ads
				Random oRandom = new Random(DateTime.Now.Millisecond);
				int iRandom = oRandom.Next(astrAds.GetLowerBound(0), astrAds.GetUpperBound(0));
				// Go through and find the <adinsert></adinsert> tags
				strBuff.Replace("<adinsert></adinsert>", astrAds[iRandom]);
				// Write to the stream
				mSR.Write(strBuff.ToString());
			}
		}

		public void Dispose()
		{
		}
	}


}
