using System;
using System.Web;

namespace SimpleModules
{
	/// <summary>
	/// Summary description for BeginEnd.
	/// <add type="SimpleModules.BeginEnd, SimpleModules" name="BeginEnd" />
	/// </summary>
	public class BeginEnd : IHttpModule
	{
		private HttpApplication mApplication;

		public void Init(System.Web.HttpApplication application)
		{
			// Wire up beginrequest
			application.BeginRequest += new System.EventHandler(BeginRequest);
			// Wire up endrequest
			application.EndRequest += new System.EventHandler(EndRequest);
			// Save the application
			mApplication = application;
		}

		public void BeginRequest(object sender, EventArgs e)
		{
			mApplication.Response.Write("<!-- Begin Request Time: " + DateTime.Now.ToString("HH:mm:ss.fffffff") + " -->");
		}

		public void EndRequest(object sender, EventArgs e)
		{
			mApplication.Response.Write("<!-- End Request Time: " + DateTime.Now.ToString("HH:mm:ss.fffffff") + " -->");
		}
		
		public void Dispose()
		{
		}

	}
}
