using System;
using System.Web;

namespace SimpleModules
{
	/// <summary>
	/// Summary description for SimpleHttpModule.
	/// <add type="SimpleModules.SimpleHttpModule, SimpleModules" name="SimpleHttpModule" />
	/// </summary>
	public class SimpleHttpModule : IHttpModule
	{
		private HttpApplication mApplication;

		public void Init(HttpApplication application)
		{
			// Save off the application
			mApplication = application;

			// Wire up all the events
			mApplication.AcquireRequestState += new EventHandler(this.AcquireRequestState);
			mApplication.AuthenticateRequest += new EventHandler(this.AuthenticateRequest);
			mApplication.AuthorizeRequest += new EventHandler(this.AuthorizeRequest);
			mApplication.BeginRequest += new EventHandler(this.BeginRequest);
			mApplication.Disposed += new EventHandler(this.Disposed);
			mApplication.EndRequest += new EventHandler(this.EndRequest);
			mApplication.Error += new EventHandler(this.Error);
			mApplication.PostRequestHandlerExecute += new EventHandler(this.PostRequestHandlerExecute);
			mApplication.PreRequestHandlerExecute += new EventHandler(this.PreRequestHandlerExecute);
			mApplication.PreSendRequestContent += new EventHandler(this.PreSendRequestContent);
			mApplication.PreSendRequestHeaders += new EventHandler(this.PreSendRequestHeaders);
			mApplication.ReleaseRequestState += new EventHandler(this.ReleaseRequestState);
			mApplication.ResolveRequestCache += new EventHandler(this.ResolveRequestCache);
			mApplication.UpdateRequestCache += new EventHandler(this.UpdateRequestCache);
		}

		private void AcquireRequestState(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("AcquireRequestState<BR>");
		}

		private void AuthenticateRequest(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("AuthenticateRequest<BR>");
		}

		private void AuthorizeRequest(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("AuthorizeRequest<BR>");
		}


		private void BeginRequest(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("BeginRequest<BR>");
		}


		private void Disposed(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("Disposed<BR>");
		}


		private void EndRequest(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("EndRequest<BR>");
		}


		private void Error(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("Error<BR>");
		}


		private void PostRequestHandlerExecute(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("PostRequestHandlerExecute<BR>");
		}


		private void PreRequestHandlerExecute(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("PreRequestHandlerExecute<BR>");
		}


		private void PreSendRequestContent(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("PreSendRequestContent<BR>");
		}


		private void PreSendRequestHeaders(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("PreSendRequestHeaders<BR>");
		}


		private void ReleaseRequestState(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("ReleaseRequestState<BR>");
		}

		private void ResolveRequestCache(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("ResolveRequestCache<BR>");
		}

		private void UpdateRequestCache(object sender, EventArgs e)
		{
			mApplication.Context.Response.Write("UpdateRequestCache<BR>");
		}

		public void Dispose()
		{
		}
	}
}
